; Version 2
; Use https://github.com/nstbayless/asm6f
INCNES "Batman (U) [!].nes"

; Macros
SEEK EQU SEEKABS
SKIP EQU SKIPREL

MACRO SKIPTO pos
    if ($ >= 0)
        SKIP pos - $
        ; just to be safe.
        if ($ != pos)
            ERROR "failed to skipto."
        endif
    endif
ENDM
FROM EQU SKIPTO

MACRO BANK bank
    SEEK (bank * $2000) + $10
ENDM
; End Macros

; NES 2.0 - SNES Controllers
;SEEK $0
;HEX 4E45531A08104008000000000000002B

CurBut1 = $F5 ; BYeSUDLR - Standard
CurBut2 = $F6 ; AXLR0000
But1 = $F7
But2 = $F8
WeaponType = $A6


BANK $0E
BASE $C000

FROM $C86E
ReadJoy: ; http://wiki.nesdev.com/w/index.php/Controller_reading_code
  LDA #$01
  STA $4016
  STA CurBut1
  LSR A
  STA $4016
-:
  LDA $4016
  AND #$03
  CMP #$01
  ROL CurBut1
  BCC -

  LDA #$01
  STA CurBut2
-:
  LDA $4016
  LSR A
  ROL CurBut2
  BCC -
  ; Test SNES
  LDA #$01
  BIT CurBut2
  BEQ @snes
  LSR A
  STA CurBut2
@snes:
  RTS
  ; NOP

FROM $DDBB
  JMP SelectWeapon ; LDA $F5
  NOP              ; AND #$10

FROM $EDB3
  JSR TurboButtons ; JSR $C89B

FROM $F800
SelectWeapon:
  ; Do not switch weapons while firing
  LDA $04F0
  CMP #$E0
  BCC @skip

  ; L+R == Weapon 00
  LDA But2
  AND #$30
  CMP #$30
  BNE @skip2
  LDX #$00
  BEQ @setLeft
@skip2:

  LDA CurBut2
  AND #$30
  BEQ @skip
  CMP #$10
  BEQ @right
;@left:
  LDX #$C0
  LDA WeaponType
  AND #$F0
  CMP #$60
  BEQ @setLeft
  LDX #$50
  CMP #$C0
  BEQ @setLeft
  LDX #$00
  CMP #$50
  BNE @skip
@setLeft:
  JMP $DDD7
@right:
  LDA WeaponType
  AND #$F0
  CMP #$60
  BEQ @skip
;@setRight:
  JMP $DDC1
@skip:
  LDA CurBut1
  AND #$10
  JMP $DDBF

TurboButtons:
  JSR $C89B ; Read Joys

  LDA But2 ; SNES A - Turbo NES A, SNES X - Turbo NES B
  AND #$C0
  EOR CurBut1
  STA CurBut1
  RTS
